<script lang="ts">
  import { base } from '$app/paths';
  import { iCanHasGeoLocation, noOp } from '@/utils';
  import { onDestroy, onMount } from 'svelte';
  import { MetaTags } from 'svelte-meta-tags';
  import { replace } from 'svelte-spa-router';

  import Modal from '@/components/modal.svelte';
  let iCanHasSubmitLocation = false;
  let watchId: number | null = null;
  //eslint-disable-next-line
  let lastKnownLocation: GeolocationPosition | null = null;
  let lastUpdateTimestamp: number | null = null;
  let error: string | null = null;
  /**
   * Toggle the modal visibility.
   * @returns {void}
   */
  const toggleModal = (): void => {
    iCanHasSubmitLocation = !iCanHasSubmitLocation;
  };

  /**
   * Start getting the device location.
   * @returns {void}
   */
  const startGettingLocation = (): void => {
    if (!watchId) {
      if (iCanHasGeoLocation()) {
        navigator.geolocation.getCurrentPosition(
          (position) => {
            lastKnownLocation = position;
            lastUpdateTimestamp = Math.floor(Date.now() / 1000);
          },
          (err) => {
            error = err.message;
          },
          {
            maximumAge: 0,
            enableHighAccuracy: true
          }
        );
        watchId = navigator.geolocation.watchPosition(
          (position) => {
            lastKnownLocation = position;
            Math.floor(Date.now() / 1000);
          },
          (err) => {
            error = err.message;
          },
          {
            enableHighAccuracy: true,
            maximumAge: 0
          }
        );
      } else {
        error = 'Your browser does not support geolocation.';
      }
    }
  };

  /**
   * Check if we can get the device location.
   * @returns {void}
   */
  onMount(() => {
    if (!iCanHasGeoLocation()) {
      error = 'Your browser does not support geolocation.';
    }
  });

  /**
   * Clear watchId if any
   */
  onDestroy(() => {
    if (watchId) {
      navigator.geolocation.clearWatch(watchId);
    }
  });

  /**
   * Toggle the modal visibility.
   * @returns {void}
   */
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  const toRecord: () => Record<string, any> = (): Record<string, any> => {
    if (lastKnownLocation == null) {
      return {};
    }
    return {
      // safari seems to return invalid timestamps, let's use our own if  any
      timestamp: lastUpdateTimestamp ?? lastKnownLocation.timestamp,
      location: {
        latitude: lastKnownLocation.coords.latitude,
        longitude: lastKnownLocation.coords.longitude,
        accuracy: lastKnownLocation.coords.accuracy,
        heading: lastKnownLocation.coords.heading,
        altitude: lastKnownLocation.coords.altitude,
        speed: lastKnownLocation.coords.speed,
        altitudeAccuracy: lastKnownLocation.coords.altitudeAccuracy
      }
    };
  };
</script>

<MetaTags title="Collect - Location" description="Get the location of your device." />
<div>
  <h1>Location</h1>
  <h2 style="width: 100vw;text-align:center">
    <a href="{base}/#/" on:click={() => replace(`${base}/#/`)}>Home</a>
  </h2>
  <div>
    {#if error}
      <div class="error">{error}</div>
    {:else}
      <div class="location-actions">
        <i
          class="fa-2x fa-solid fa-location"
          style="padding:5px;opacity: {watchId ? 0.5 : 1};"
          role="button"
          tabindex="0"
          on:click={startGettingLocation}
          on:keydown={noOp}
        />
        <i
          class="fa-2x fa-solid fa-upload"
          style="display: {lastKnownLocation ? 'initial' : 'none'};margin-left: 40px"
          id="location-upload"
          aria-roledescription="Upload last known location"
          role="button"
          tabindex="0"
          on:click={toggleModal}
          on:keydown={noOp}
        />
      </div>
      <div class="location-wrapper">
        <div class="location">
          {#if lastKnownLocation}
            <p>Latitude: {lastKnownLocation.coords.latitude}</p>
            <p>Longitude: {lastKnownLocation.coords.longitude}</p>
          {:else if watchId}
            <p>Getting location ...</p>
          {/if}
        </div>
      </div>

      {#if iCanHasSubmitLocation && lastKnownLocation != null && lastKnownLocation.coords != null}
        <Modal on:click={toggleModal} uploadExtras={toRecord()} contentType="application/json" />
      {/if}
    {/if}
  </div>
</div>

<style>
  .location-actions {
    display: flex;
    align-items: center;
    justify-content: center;
    max-width: 100px;
    margin: 20px auto;
  }
  .location-wrapper {
    display: flex;
    justify-content: center;
    align-items: center;
  }
</style>
